routes/web.php
<?php

use App\Http\Controllers\Backend\Admin\AdminLoginController;
use App\Http\Controllers\Backend\Admin\AdminRegisterController;
use App\Http\Controllers\Backend\Admin\ProfileController;
use App\Http\Controllers\Backend\Blog\BlogController;
use App\Http\Controllers\Backend\Blog\BlogDetailController;
use App\Http\Controllers\Backend\Configuration\ConfigController;
use App\Http\Controllers\Backend\CountUp\CountUpController;
use App\Http\Controllers\Backend\Faq\FaqController;
use App\Http\Controllers\Backend\MainService\MainServiceController;
use App\Http\Controllers\Backend\MainService\ServiceCatController;
use App\Http\Controllers\Backend\Offer\OfferController;
use App\Http\Controllers\Backend\Popular\PopularWorkController;
use App\Http\Controllers\Backend\ServiceCard\ServiceCardController;
use App\Http\Controllers\Backend\ServiceDetail\ServiceDetailController;
use App\Http\Controllers\Backend\Team\TeamController;
use App\Http\Controllers\Backend\Update\UpdateController;
use App\Http\Controllers\ContactMailController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\Frontend\Contact\ContactController;
use App\Http\Controllers\Frontend\Contact\ContactUsController;
use App\Http\Controllers\Frontend\FrontShowController;
use App\Http\Controllers\PageController;
use Faker\Guesser\Name;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

///////////////////front-end//////////////////////route//
Route::get('/', [PageController::class, 'indexpage'])->name('getindex');
Route::get('/index', [PageController::class, 'gethome'])->name('getHome');
Route::get('/about', [PageController::class, 'getabout'])->name('getAbout');
Route::get('/news', [PageController::class, 'getblog'])->name('getBlog');
Route::get('/news-detail/{slug}', [PageController::class, 'getblogdetail'])->name('getBlogDetail');
Route::get('/contact', [PageController::class, 'getcontact'])->name('getContact');
Route::get('/service', [PageController::class, 'getservice'])->name('getService');
Route::get('/service-detail/{slug}', [PageController::class, 'getservicedetail'])->name('getServiceDetail');
Route::get('/service/card/{slug1}', [PageController::class, 'getscdetail'])->name('getscDetail');
Route::get('/service/card-two/{slug2}', [PageController::class, 'getsctwo'])->name('getsctwo');
Route::get('/service/card-three/{slug3}', [PageController::class, 'getscthree'])->name('getscthree');


//contact route
Route::resource('/contactus', ContactController::class);
Route::post('/subscriber', [ContactUsController::class,'storeContact'])->name('store.contact');
Route::get('/subscriber', [ContactUsController::class, 'getContact'])->name('getSubs');
Route::delete('/del/subscriber/{id}', [ContactUsController::class, 'deleteSub'])->name('deleteSub');

//////////////Front-end routes END/////////////
//login
Route::match(['get','post'],'/login',[AdminLoginController::class, 'login'])->name('adminLogin');
//auth part
Route::group(['middleware'=>'auth'], function(){
//to dashboard
Route::get('/dashboard', [DashboardController::class, 'getIndex'])->name('index');
//get password
Route::get('/getpassowrd',[ProfileController::class,'password'])->name('getPassword');
//check password
Route::post('/check-password', [ProfileController::class, 'chkUserPassword'])->name('checkpassword');
//change password
Route::post('/change-password/{id}',[ProfileController::class,'updatePassword'])->name('changepassword');
//to get profile
Route::get('/getprofile', [ProfileController::class, 'profile'])->name('profile');
//update profile
Route::post('/update-profile/{id}',[ProfileController::class, 'updateProfile'])->name('updateprofile');

/////////Crud operation//////////
//ServiceCard
Route::resource('/service-card', ServiceCardController::class);
//Offer crud
Route::resource('/offers', OfferController::class);
//Popular work
Route::resource('/popularworks', PopularWorkController::class);
//Team member
Route::resource('/teams', TeamController::class);
//Blog crud
Route::resource('/blogs', BlogController::class);
//Main service
Route::resource('/mainservice', MainServiceController::class);
//Count ups
Route::resource('/countups', CountUpController::class);
//FAQ
Route::resource('/faqs', FaqController::class);
//Updates Routes
Route::get('update/content',[UpdateController::class, 'getUpdate'])->name('getupdate');

//page settings
Route::get('/settings', [ConfigController::class, 'getConfiguration'])->name('pageset');
Route::post('/settings', [ConfigController::class, 'postConfiguration'])->name('pageset.update');

});

//logout
Route::get('/logout', [AdminLoginController::class, 'logout'])->name('adminLogout');

// Route::post('/sendmail',[ContactMailController::class, 'sendEmail'])->name('sendemail');

app/Models/Offer.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Offer extends Model
{
    use HasFactory;
    protected $fillable = ['title', 'description', 'image'];
}

app/Http/Controllers/Backend/Admin/AdminLoginController.php
<?php

namespace App\Http\Controllers\Backend\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Session;

class AdminLoginController extends Controller
{
    public function getLogin()
    {
        return view('backend.admin.login');
    }

    public function getSignup()
    {
        return view('backend.admin.register');
    }

        //admin login
        public function login(Request $request){
            if($request->isMethod('post')){
                $data = $request->all();
            //   dd($data);
                $rules = [
                    'email' => 'required|email|max:255',
                    'password' => 'required'
                ];
                $customMessages = [
                    'email.required' => 'Email is required',
                    'email.email' => 'Enter a valid mail',
                    'email.max' => 'Not more than 255 characters',
                    'password.required' => 'Password is reqired',
                    'password.password' => 'Wrong passowrd'
                ];
                $this->validate($request, $rules, $customMessages);
              
                if(Auth::attempt(['email' => $data['email'], 'password' => $data['password']]))
                {
                    return redirect()->route('index');
                }
                else{
                    Session::flash('error', 'Invalid credentials');
                    return redirect()->route('adminLogin');
                }
            }
            //check if logged in
            if(Auth::check()){
                    return redirect()->route('index');
            }
            else{
                return view('backend.admin.login');        
            }
        }

        //logout
        
    //logout 
    public function logout(){
        Auth::logout();
        Session::flash('success_message', 'logout successful');
        return redirect()->route('adminLogin');
    }
}

app/Http/Controllers/Backend/Admin/ProfileController.php
<?php

namespace App\Http\Controllers\Backend\Admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\File;

class ProfileController extends Controller
{
    public function profile(){

        $admin =  Auth::user();
        // dd($user);
        return view('backend.admin.profile', compact('admin'));
    }

    public function updateProfile(Request $request, $id){
        $data = $request->all();
        //validation
        $rules = [
            'email' => 'required|email|max:255',
            'name' => 'required|max:255'
        ];
        $customMessages = [
            'email.required' => 'Email is required',
            'email.email' => 'Enter a valid mail',
            'email.max' => 'Not more than 255 characters',
            'name.required' => 'Name is reqired',
            'name.max' => 'No more than 255 characters'
        ];
        $this->validate($request, $rules, $customMessages);//validation ends
        $profile=new User();
        $profile = $profile->find($id);
        $data = $request->all();
        if ($request->has('image')) {
            $file_name = "Image-" . date('ymdhis') . rand(0, 999) . "." . $request->image->getClientOriginalExtension();
            $path = public_path() . '/uploads/admin';
            if (!File::exists($path)) {
                File::makeDirectory($path, 0777, true, true);
            }
            $success = $request->image->move($path, $file_name);
            if ($success) {
               $data['image'] = $file_name;
            } else {
                $data['image'] = null;
            }
            $destination = 'uploads/admin/' . $profile->image;
            if (file::exists($destination)) {
                file::delete($destination);
            }
        }
        $profile->fill($data);
        $status = $profile->save();
        if ($status) {
            Session::flash('success', 'Profile updated Successfully');
            return redirect()->back();
        } 

    }

       //Change Admin Password
    public function password(){
        $admin = User::where('email', Auth::user()->email)->first();
        return view ('backend.admin.changepassword', compact('admin'));
    }

   //Check Admin Current Password
   public function chkUserPassword(Request $request){
    $data = $request->all();
    $current_password = $data['current_password'];
    $user_id = Auth::user()->id;
    $check_password = User::where('id', $user_id)->first();
    if (Hash::check($current_password, $check_password->password)){
        return "true"; die;
    } else {
        return "false"; die;
    }
}

// Update Admin password
 public function updatePassword(Request $request){
    $data = $request->all();
    $validateData = $request->validate([
        'current_password' => 'required|max:255',
        'password' => 'required',
        'password_confirmation' => 'required_with:password|same:password',
    ]);
    $admin = User::where('email', Auth::user()->email)->first();
    $current_password = $admin->password;
    if(Hash::check($data['current_password'], $current_password)){
        $admin->password = bcrypt($data['password']);
        $admin->save();
        Session::flash('success_message', 'Your Password Has Been Changed Successfully');
        return redirect()->back();
    } else {
        Session::flash('error_message', 'Your Current Password Does Not Match with our Database');
        return redirect()->back();
    }
}
}

app/Http/Controllers/Backend/Blog/BlogController.php
<?php

namespace App\Http\Controllers\Backend\Blog;

use App\Http\Controllers\Controller;
use App\Models\Blog;
use Brian2694\Toastr\Facades\Toastr;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Session;
// use RealRashid\SweetAlert\Facades\Alert;
use Alert;

class BlogController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $blogs = Blog::all();
        return view('backend.blogs.index', compact('blogs'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('backend.blogs.create')->with('success','Item created successfully.');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'title' => 'required',
            'name' => 'required',
            'image' => 'required|image|mimes:jpeg,png,jpg,gif,svg',
            'author' => 'required',
            'date' => 'required',
        ]);
        $blog=new Blog();
        $data = $request->all();
        $blog->slug = Str::slug($request->title);
        if ($request->has('image')) {
            $file_name = "Image-" . date('ymdhis') . rand(0, 999) . "." . $request->image->getClientOriginalExtension();
            $path = public_path() . '/blogimage';
            if (!File::exists($path)) {
                File::makeDirectory($path, 0777, true, true);
            }
            $success = $request->image->move($path, $file_name);
            if ($success) {
               $data['image'] = $file_name;
            } else {
                $data['image'] = null;
            }

        }
        $blog->fill($data);
        $status = $blog->save();
        if ($status) {
            // session()->flash('success','Item created successfully.');
            return redirect()->route('blogs.index')->with('success','Blog added successfully');
        }
        // alert()->success('Success','Blog Added Successfully');

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $blog = Blog::find($id);
        return view('backend.blogs.view', compact('blog'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $blog = Blog::find($id);
        return view('backend.blogs.edit', compact('blog'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'title' => 'required',
            'name' => 'required',
            'author' => 'required',
            'date' => 'required',
        ]);

        $blog=new Blog();
        $blog = $blog->find($id);
        $data = $request->all();
        $blog->slug = Str::slug($request->title);
        if ($request->has('image')) {
            $file_name = "Image-" . date('ymdhis') . rand(0, 999) . "." . $request->image->getClientOriginalExtension();
            $path = public_path() . '/blogimage';
            if (!File::exists($path)) {
                File::makeDirectory($path, 0777, true, true);
            }
            $destination = $path.'/'.$blog->image;
            if (file::exists($destination)) {
                file::delete($destination);
            }
            $success = $request->image->move($path, $file_name);
            if ($success) {
               $data['image'] = $file_name;
            } else {
                $data['image'] = null;
            }
            $destination = 'blogimage/' . $blog->image;
            if (file::exists($destination)) {
                file::delete($destination);
            }
        }
        $blog->fill($data);
        $status = $blog->save();
        if ($status) {
            Session::flash('success', 'Blog Updated Successfully');
            return redirect()->route('blogs.index');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $blog = new Blog();
        $blog = $blog->find($id);
        $destination = 'blogimage/' . $blog->image;
        if (file::exists($destination)) {
                file::delete($destination);
        }
        if ($blog) {
            $blog->delete();
        }
        return redirect()->route('blogs.index')->with('success', 'Blog deleted successfully!');

    }
}

app/Http/Controllers/Backend/Update/UpdateController.php
<?php

namespace App\Http\Controllers\Backend\Update;

use App\Http\Controllers\Controller;
use App\Models\CountUp;
use App\Models\Offer;
use App\Models\ServiceCard;
use Illuminate\Http\Request;

class UpdateController extends Controller
{
    public function getUpdate()
    {
        $service = [1,2,3];
        $about = 1;
        $count = 1;
        $countup = CountUp::where('id',$count)->first();
        $offer = Offer::where('id',$about)->first();
        $service = ServiceCard::where('id',$service)->first();
        return view('backend.updatetabs.update', compact('countup','offer','service'));
    }
}

resources/views/backend/offers/create.blade.php
@extends('backend.layouts.app')
@section('content')
@push('title')
About Create   
@endpush
<div class="row">
    <div class="col-lg-12">
        <div class="card">
            <div class="card-header align-items-center d-flex">
                <h4 class="card-title mb-0 flex-grow-1">Create Offers</h4>
             
            </div><!-- end card header -->
            <div class="card-body">
                <div class="live-preview">
                    <div class="row gy-4">
                        @include('backend.layouts.message')
                        <form action="{{ route('offers.store') }}" method="POST" enctype="multipart/form-data">
                            @csrf
                            <div class="row">
                                <div class="col-lg-6">
                                    <div class="mb-3">
                                        <label for="username" class="form-label">Title</label>
                                        <input type="text" name="title" class="form-control" id="username" >
                                    </div>
                                </div>
                                <!--end col-->
                                <div class="col-lg-6">
                                    <div class="mb-3">
                                        <label for="exampleFormControlTextarea5" class="form-label">Image</label>
                                        <input class="form-control" type="file" name="image" id="image" accept="image/*" onchange="readURL(this);">
                                    </div>
                                </div>
                                <!--end col-->
                                <div class="col-lg-12">
                                    <div class="mb-3">
                                    <label><strong>Description :</strong></label>
                                    <textarea class="ckeditor form-control" name="description"></textarea>
                                    </div>
                                </div>
                                <!--end col-->
                            </div>
                            <div class="row">
                                <div class="col-lg-12 d-flex justify-content-end gap-2">
                                    <button type="submit" class="btn btn-success ">Create</button>
                                    <a href="{{ route('offers.index') }}" class="btn btn-secondary ">Back</a>
                                </div>
                            </div>
                        </form>
                    </div>   
                    <!--end row-->
                </div>
            </div>
        </div>
    </div>
    <!--end col-->
</div>

@endsection

@section('js')
<script src="//cdn.ckeditor.com/4.14.0/standard/ckeditor.js"></script>
<script type="text/javascript">
    $(document).ready(function() {
       $('.ckeditor').ckeditor();
    });
</script>
@endsection

resources/views/backend/offers/edit.blade.php
@extends('backend.layouts.app')
@section('content')
{{-- @push('title')
Update About  
@endpush --}}
<div class="row">
    <div class="col-lg-12">
        <div class="card">
            <div class="card-header align-items-center d-flex">
                <h4 class="card-title mb-0 flex-grow-1">About</h4>
               
            </div><!-- end card header -->
            <div class="card-body">
                <div class="live-preview">
                    <div class="row gy-4">
                        @include('backend.layouts.message')
                        <form action="{{ route('offers.update', $offer->id) }}" method="POST" enctype="multipart/form-data">
                            @method('patch')
                            @csrf
                            <div class="row">
                                <div class="col-lg-6">
                                    <div class="mb-3">
                                        <label for="username" class="form-label">Title</label>
                                        <input type="text" name="title" class="form-control" id="username" value="{{ $offer->title  }}">
                                    </div>
                                </div>
                                <!--end col-->
                                <div class="col-lg-6">
                                    <div class="mb-3">
                                        <label for="exampleFormControlTextarea5" class="form-label">Image</label>
                                        <input class="form-control" type="file" name="image" id="image" accept="image/*" onchange="readURLOffer(this);">
                                        @if (empty($offer->image))
                                        <img src="" width="100px" id="ofimg">
                                    @else
                                    <img src="/offerimage/{{ $offer->image }}" width="100px" id="ofimg">                                
                                    @endif
                                        
                                    </div>
                                </div>
                                <div class="col-lg-12">
                                    <div class="mb-3">
                                    <label><strong>Description :</strong></label>
                                    <textarea class="ckeditor form-control" name="description">{{ $offer->description }}</textarea>
                                    </div>
                                </div>
                                <!--end col-->
                            </div>
                            <div class="row">
                                <div class="col-lg-12 d-flex justify-content-end gap-2">
                                    <button type="submit" class="btn btn-success ">Update</button>
                                    <a href="{{ route('offers.index') }}" class="btn btn-secondary ">Back</a>
                                </div>
                            </div>
                        </form>
                    </div>   
                    <!--end row-->
                </div>
            </div>
        </div>
    </div>
</div>
    <!--end col-->
</div>

@endsection

@section()('js')
<script>
function readURLOffer(input){
    if(input.files && input.files[0]);
    var reader = new FileReader();
    reader.onload = function (e){
        $("#ofimg").attr('src', e.target.result).width(100);
    }
    reader.readAsDataURL(input.files[0])
}
</script>

<script src="//cdn.ckeditor.com/4.14.0/standard/ckeditor.js"></script>
<script type="text/javascript">
    $(document).ready(function() {
       $('.ckeditor').ckeditor();
    });
</script>
@endsection

resources/views/backend/offers/index.blade.php
@extends('backend.layouts.app')
@section('content')
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/5.2.0/css/bootstrap.min.css">
<link rel="stylesheet" href="https://cdn.datatables.net/1.13.1/css/dataTables.bootstrap5.min.css">
@push('title')
 About
@endpush

            <div class="row">
                <div class="col-xl-12">
                    <div class="card">
                        <div class="card-header align-items-center d-flex">
                            {{-- <h4 class="card-title mb-0 flex-grow-1 text-end"><a href="{{ route('offers.create') }}" class="btn btn-primary">Add Offer</a> </h4> --}}
                           
                        </div><!-- end card header -->

                        <div class="card-body">
                            @include('backend.layouts.message')
                            <div class="live-preview">
                                <div class="table-responsive">
                                    <table class="table align-middle table-nowrap mb-0" id="example">
                                        <thead>
                                            <tr>
                                                <th scope="col">ID</th>
                                                <th scope="col">Titles</th>
                                                <th scope="col">Description</th>
                                                <th scope="col">Image</th>
                                                <th scope="col">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @foreach ($offers as $offer)
                                            <tr>
                                                <td>{{ $loop->index + 1 }}</td>
                                                <td>{{ $offer->title }}</td>
                                                <td>{!! Str::limit($offer->description,50) !!}</td>
                                                <td><img src="/offerimage/{{ $offer->image }}" width="100px"></td>
                                                <td>
                                                    <div class="hstack gap-3 flex-wrap">
                                                        <a href="{{ route('offers.show', $offer->id) }}" class="link-success fs-15"><i class="ri-eye-fill align-middle"></i></a>
                                                        <a href="{{ route('offers.edit', $offer->id) }}" class="link-success fs-15"><i class="ri-edit-2-line"></i></a>
                                                        <form method="post" action="{{route('offers.destroy',$offer->id)}}">
                                                            @method('delete')
                                                            @csrf
                                                            <button type="submit" class="btn btn-danger btn-sm"><i class="ri-delete-bin-line"></i></button>
                                                        </form>
                                                    </div>
                                                </td>
                                            </tr> 
                                            @endforeach
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
@endsection

@push('js')
<script src="https://code.jquery.com/jquery-3.5.1.js"></script>
    <script src="https://cdn.datatables.net/1.13.1/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.1/js/dataTables.bootstrap5.min.js"></script>
    <script>
        $(document).ready(function () {
    $('#example').DataTable();
});
</script>
    
@endpush

resources/views/backend/offers/view.blade.php
@extends('backend.layouts.app')
@section('content')
@push('title')
About View   
@endpush
<div class="container justify-content-center">
<div class="row mx-2">
        <div class="col-md-6 col-lg-12">
            <div class="card">
                <div class="card-header">
                    <a href="{{route('offers.index')}}" class="btn btn-secondary float-end"> Back</a>
                    MainService Detail  
                </div>
                <div class="card-body">
                    <p>ID : {{ $offer->id }}</p>
                    <p>Title : {{ $offer->title }}</p>
                    <p>Description : {!! $offer->description !!}</p>
                    <p>Image :<img src="/offerimage/{{ $offer->image }}" width="100px"></p>
                </div>
            </div>
        </div>
</div>
</div>

@endsection